<?
		$rubrique = 3;
		$meta_description = "Lire une ligne d'un fichiers en C";
		$meta_keywords = "get, next, line, lire, prochaine, ligne fichier, langage, C, tutoriel, tutorial, cour, programmation, informatique";
		$titre_page = "getNextLine";
		$urlCss = "./article.css";
		$xhtml=true;
        
			$Auteur="Nicolas Joseph";
			$Licence="2";
			$Annee="2006";
		
		$dateBrute['date'] = '19 Mars 2005';
		$dateBrute['miseajour'] = '10 Aout 2005';
		
				$topicType = 'Whitepaper';
			include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <div style="text-align:center;">
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td align="center" style="text-align:left">
	<br/><h1>Lire une ligne d'un fichiers en C</h1><p class="dateArticle">
		Date de publication : 19 Mars 2005 , Date de mise &agrave; jour : 10 Aout 2005</p><p style="text-align: center;">
        Par
        <a class="auteur" href="http://www.developpez.net/forums/member.php?u=41072">Nicolas Joseph</a> <a class="homepage" href="http://nicolasj.developpez.com"> (home)</a><br/>&nbsp;</p><div class="synopsis">
		Cette fonction a pour but de lire la prochaine ligne du flux de sortie  et de la placer dans une zone de mmoire alloue dynamiquement dont l'adresse est stocke dans la variable .
		En cas d'erreur, la fonction retourne la valeur EXIT_FAILURE. Si le la fichier du fichier est atteinte,  est mis  NULL et la fonction retourne EXIT_FAILURE.
	</div>


		

	<br/><br/>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">getNextLine.h</td></tr><tr><td class="code"><pre><span class="c_code"><span class="c_define">#ifndef H_NJ_GETNEXTLINE_1903052321</span>
<span class="c_define">#define H_NJ_GETNEXTLINE_1903052321</span>

<span class="c_define">#include &lt;stdio.h&gt;</span>

<span class="c_define">#define skipNextLine(file) getNextLine ((file), NULL)</span>

<span class="c_type">int</span> getNextLine (FILE *stream, <span class="c_type">char</span> **pp_line);

<span class="c_define">#endif /* not H_NJ_GETNEXTLINE_1903052321 */</span></span></pre></td></tr></table></div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">getNextLine.c</td></tr><tr><td class="code"><pre><span class="c_code"><span class="c_define">#include &lt;stdlib.h&gt;</span>
<span class="c_define">#include "getNextLine.h"</span>

<span class="c_type">int</span> getNextLine (FILE *stream, <span class="c_type">char</span> **pp_line)
{
   <span class="c_type">int</span> ret = EXIT_SUCCESS;

   <span class="c_keyword">if</span> (stream)
   {
      <span class="c_type">int</span> end = 0;
      <span class="c_type">char</span> *line = <span class="c_keyword">NULL</span>;
      size_t size = 1;
      <span class="c_type">int</span> i = 0;

      <span class="c_keyword">while</span> (ret == EXIT_SUCCESS &amp;&amp; end == 0)
      {
         <span class="c_type">int</span> c = fgetc (stream);
         <span class="c_keyword">switch</span> (c)
         {
            <span class="c_keyword">case</span> EOF:
               <span class="c_keyword">if</span> (feof (stream))
               {
                  <span class="c_keyword">if</span> (pp_line &amp;&amp; !line)
                  {
                     *pp_line = <span class="c_keyword">NULL</span>;
                     ret = EXIT_FAILURE;
                  }
                  end = 1;
               }
               <span class="c_keyword">else</span>
               {
                  ret = EXIT_FAILURE;
               }
            <span class="c_keyword">break</span>;
            <span class="c_keyword">default</span>:
               <span class="c_keyword">if</span> (pp_line)
               {
                  <span class="c_keyword">if</span> (i == size - 1)
                  {
                     <span class="c_type">void</span> *tmp = <span class="c_keyword">NULL</span>;

                     size &lt;&lt;= 1;
                     tmp = realloc (line, <span class="c_keyword">sizeof</span> (*line) * size);
                     <span class="c_keyword">if</span> (tmp)
                     {
                        line = tmp;
                     }
                     <span class="c_keyword">else</span>
                     {
                        free (line);
                        line = <span class="c_keyword">NULL</span>;
                        ret = EXIT_FAILURE;
                     }
                  }
                  <span class="c_keyword">if</span> (line)
                  {
                     <span class="c_keyword">if</span> (c == '\n')
                     {
                        end = 1;
                     }
                     <span class="c_keyword">else</span>
                     {
                         line[i] = c;
                         i++;
                     }
                  }
               }
            <span class="c_keyword">break</span>;
         }
      }
      <span class="c_keyword">if</span> (pp_line &amp;&amp; line)
      {
          line[i] = '\0';
          *pp_line = line;
      }
   }
   <span class="c_keyword">else</span>
   {
      ret = EXIT_FAILURE;
   }
   <span class="c_keyword">return</span> (ret);
}</span></pre></td></tr></table></div>
		<div class="paragraph">
			Voic un exemple d'utilisation de cette fonction dans une boucle pour lire l'intgralit d'un fichier :
		</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">char</span> *p_line = <span class="c_keyword">NULL</span>;
FILE *file = fopen (...);

<span class="c_keyword">while</span> (getNextLine (file, &amp;p_line) &amp;&amp; p_line)
{
   ...
   free (p_line);
   p_line = <span class="c_keyword">NULL</span>;
}</span></pre></td></tr></table></div>
	<br/><?include("http://nicolasj.developpez.com/sources/sources.inc");?><hr/><p style="text-align:center;"><a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml11" alt="Valid XHTML 1.1!" height="31" width="88"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"/></a></p><div id="xiti-logo" style="text-align:center;">
<a href="http://www.xiti.com/xiti.asp?s=205564" title="Mesurez votre audience">
<script type="text/javascript">
<!--
Xt_param = 's=205564&p=sources/getnextline';
Xt_r = document.referrer;
Xt_h = new Date();
Xt_i = '<img width="39" height="25" border="0" ';
Xt_i += 'src="http://logv28.xiti.com/hit.xiti?'+Xt_param;
Xt_i += '&hl='+Xt_h.getHours()+'x'+Xt_h.getMinutes()+'x'+Xt_h.getSeconds();
if(parseFloat(navigator.appVersion)>=4)
{Xt_s=screen;Xt_i+='&r='+Xt_s.width+'x'+Xt_s.height+'x'+Xt_s.pixelDepth+'x'+Xt_s.colorDepth;}
document.write(Xt_i+'&ref='+Xt_r.replace(/[<>"]/g, '').replace(/&/g, '$')+'" title="Analyse d\'audience">');
//-->
</script>
<object>
<noscript>
<div id="xiti-logo-noscript-205564">
Mesure d'audience ROI frequentation par <img width="39" height="25" src="http://logv28.xiti.com/hit.xiti?s=205564" alt="Analyse d'audience" />
</div>
</noscript>
</object>
</a></div>
	  </td>
		</tr>
		   </table></div>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>